Gentoo Forums
Gentoo Forums
Gentoo Forums
Quick Search: in
Cannot mask PyPy use flag for a specific package
View unanswered posts
View posts from last 24 hours

 
Reply to topic    Gentoo Forums Forum Index Portage & Programming
View previous topic :: View next topic  
Author Message
stevenj36
n00b
n00b


Joined: 30 Jun 2013
Posts: 2

PostPosted: Tue Jul 02, 2013 11:52 am    Post subject: Cannot mask PyPy use flag for a specific package Reply with quote

While emerging deluge, I ran into an error emerging net-zope/zope-fixers because it was trying to use pypy2.0, and failing.
I realize that pypy is "unsupported software" but my issue is getting portage to pass along the use flags that I want, not anything pypy specific. If I can get the right use flags passed in, and it still fails somehow due to pypy, i'll move this to the unsupported forum area.
None of my attempts at disallowing it from using pypy have been successful.
package.use.mask
Code:

sys-apps/portage -pypy2_0
net-zope/zope-fixers python_targets_pypy2_0

package.use
Code:

ev-python/pypy doc examples
net-zope/zope-fixers -python_targets_pypy2_0
app-text/poppler -qt4
dev-util/cmake -qt4
gnome-base/gvfs -http
=media-libs/mesa-9.1.2-r1 xa
>=x11-libs/libdrm-2.4.45 libkms
# required by www-client/chromium-27.0.1453.110
# required by chromium (argument)
=media-libs/mesa-9.1.2-r1 gles2
# required by www-client/chromium-27.0.1453.110
# required by chromium (argument)
>=dev-libs/libxml2-2.9.0-r2 icu
# required by www-client/chromium-27.0.1453.110
# required by chromium (argument)
=sys-libs/zlib-1.2.7 minizip
sys-apps/portage python_single_target_pypy2_0 python_targets_pypy2_0 -python_targets_python2_7 -python_targets_python3_2
# required by net-p2p/deluge-1.3.5
# required by deluge (argument)
=net-libs/rb_libtorrent-0.16.8 python
# required by net-libs/rb_libtorrent-0.16.8
# required by net-p2p/deluge-1.3.5
# required by deluge (argument)
=dev-libs/boost-1.49.0-r2 python
# required by www-client/firefox-17.0.7
# required by firefox (argument)
=dev-lang/python-2.7.3-r3 sqlite
# required by media-libs/sk1libs-0.9.1
# required by media-gfx/uniconvertor-1.1.5
# required by media-gfx/inkscape-0.48.4
# required by inkscape (argument)
=media-libs/lcms-1.19 python


make.conf
Code:

# These settings were set by the catalyst build script that automatically
# built this stage.
# Please consult /usr/share/portage/config/make.conf.example for a more
# detailed example.
CFLAGS="-march=native -O2"
CXXFLAGS="${CFLAGS}"
# WARNING: Changing your CHOST is not something that should be done lightly.
# Please consult http://www.gentoo.org/doc/en/change-chost.xml before changing.
CHOST="x86_64-pc-linux-gnu"
# These are the USE flags that were used in addition to what is provided by the
# profile used for building.
USE="bash-completion bindist mmx sse sse2 -qt4 -gnome"
MAKEOPTS="-j9"

SYNC="rsync://rsync.us.gentoo.org/gentoo-portage"
PYTHON_TARGETS="pypy2_0 python2_7 python3_2"
PYTHON_SINGLE_TARGET="python2_7"
USE_PYTHON="2.7 2.7-pypy-2.0 3.2"
GENTOO_MIRRORS="http://gentoo.osuosl.org/"

FEATURES="-ccache"
CCACHE_SIZE="6GB"


emerge --info =net-zope/zope-fixers-1.0
Code:

Portage 2.1.12.2 (default/linux/amd64/13.0/desktop, gcc-4.6.3, glibc-2.15-r3, 3.8.13-gentoo x86_64)
=================================================================
                        System Settings
=================================================================
System uname: Linux-3.8.13-gentoo-x86_64-Intel-R-_Core-TM-_i7-3970X_CPU_@_3.50GHz-with-gentoo-2.2
KiB Mem:    32919392 total,  23661436 free
KiB Swap:    1990228 total,   1990228 free
Timestamp of tree: Sat, 29 Jun 2013 09:15:01 +0000
ld GNU ld (GNU Binutils) 2.22
ccache version 3.1.9 [enabled]
app-shells/bash:          4.2_p45
dev-lang/python:          2.7.3-r3, 3.2.3-r2
dev-util/ccache:          3.1.9
dev-util/cmake:           2.8.10.2-r2
dev-util/pkgconfig:       0.28
sys-apps/baselayout:      2.2
sys-apps/openrc:          0.11.8
sys-apps/sandbox:         2.6-r1
sys-devel/autoconf:       2.13, 2.69
sys-devel/automake:       1.10.3, 1.11.6, 1.12.6
sys-devel/binutils:       2.22-r1
sys-devel/gcc:            4.6.3
sys-devel/gcc-config:     1.7.3
sys-devel/libtool:        2.4-r1
sys-devel/make:           3.82-r4
sys-kernel/linux-headers: 3.7 (virtual/os-headers)
sys-libs/glibc:           2.15-r3
Repositories: gentoo
ACCEPT_KEYWORDS="amd64"
ACCEPT_LICENSE="* -@EULA"
CBUILD="x86_64-pc-linux-gnu"
CFLAGS="-march=native -O2"
CHOST="x86_64-pc-linux-gnu"
CONFIG_PROTECT="/etc"
CONFIG_PROTECT_MASK="/etc/ca-certificates.conf /etc/env.d /etc/fonts/fonts.conf /etc/gconf /etc/gentoo-release /etc/revdep-rebuild /etc/sandbox.d /etc/terminfo"
CXXFLAGS="-march=native -O2"
DISTDIR="/usr/portage/distfiles"
FCFLAGS="-O2 -pipe"
FEATURES="assume-digests binpkg-logs ccache config-protect-if-modified distlocks ebuild-locks fixlafiles merge-sync news parallel-fetch preserve-libs protect-owned sandbox sfperms strict unknown-features-warn unmerge-logs unmerge-orphans userfetch"
FFLAGS="-O2 -pipe"
GENTOO_MIRRORS="http://gentoo.osuosl.org/"
LDFLAGS="-Wl,-O1 -Wl,--as-needed"
MAKEOPTS="-j9"
PKGDIR="/usr/portage/packages"
PORTAGE_CONFIGROOT="/"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --compress --force --whole-file --delete --stats --human-readable --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages"
PORTAGE_TMPDIR="/var/tmp"
PORTDIR="/usr/portage"
PORTDIR_OVERLAY=""
SYNC="rsync://rsync.us.gentoo.org/gentoo-portage"
USE="X a52 aac acl acpi alsa amd64 bash-completion berkdb bindist bluetooth branding bzip2 cairo cdda cdr cli consolekit cracklib crypt cups cxx dbus dri dts dvd dvdr emboss encode exif fam firefox flac fortran gdbm gif gpm gtk iconv ipv6 jpeg lcms ldap libnotify mad mmx mng modules mp3 mp4 mpeg mudflap multilib ncurses nls nptl ogg opengl openmp pam pango pcre pdf png policykit ppds qt3support readline sdl session spell sse sse2 ssl startup-notification svg tcpd tiff truetype udev udisks unicode upower usb vorbis wxwidgets x264 xcb xml xv xvid zlib" ABI_X86="64" ALSA_CARDS="ali5451 als4000 atiixp atiixp-modem bt87x ca0106 cmipci emu10k1x ens1370 ens1371 es1938 es1968 fm801 hda-intel intel8x0 intel8x0m maestro3 trident usb-audio via82xx via82xx-modem ymfpci" APACHE2_MODULES="authn_core authz_core socache_shmcb unixd actions alias auth_basic authn_alias authn_anon authn_dbm authn_default authn_file authz_dbm authz_default authz_groupfile authz_host authz_owner authz_user autoindex cache cgi cgid dav dav_fs dav_lock deflate dir disk_cache env expires ext_filter file_cache filter headers include info log_config logio mem_cache mime mime_magic negotiation rewrite setenvif speling status unique_id userdir usertrack vhost_alias" CALLIGRA_FEATURES="kexi words flow plan sheets stage tables krita karbon braindump author" CAMERAS="ptp2" COLLECTD_PLUGINS="df interface irq load memory rrdtool swap syslog" ELIBC="glibc" GPSD_PROTOCOLS="ashtech aivdm earthmate evermore fv18 garmin garmintxt gpsclock itrax mtk3301 nmea ntrip navcom oceanserver oldstyle oncore rtcm104v2 rtcm104v3 sirf superstar2 timing tsip tripmate tnt ubx" INPUT_DEVICES="keyboard mouse evdev" KERNEL="linux" LCD_DEVICES="bayrad cfontz cfontz633 glk hd44780 lb216 lcdm001 mtxorb ncurses text" LIBREOFFICE_EXTENSIONS="presenter-console presenter-minimizer" OFFICE_IMPLEMENTATION="libreoffice" PHP_TARGETS="php5-3" PYTHON_SINGLE_TARGET="python2_7" PYTHON_TARGETS="pypy2_0 python2_7 python3_2" RUBY_TARGETS="ruby19 ruby18" USERLAND="GNU" VIDEO_CARDS="fbdev glint intel mach64 mga nouveau nv r128 radeon savage sis tdfx trident vesa via vmware dummy v4l" XTABLES_ADDONS="quota2 psd pknock lscan length2 ipv4options ipset ipp2p iface geoip fuzzy condition tee tarpit sysrq steal rawnat logmark ipmark dhcpmac delude chaos account"
USE_PYTHON="2.7 2.7-pypy-2.0 3.2"
Unset:  CPPFLAGS, CTARGET, EMERGE_DEFAULT_OPTS, INSTALL_MASK, LANG, LC_ALL, PORTAGE_BUNZIP2_COMMAND, PORTAGE_COMPRESS, PORTAGE_COMPRESS_FLAGS, PORTAGE_RSYNC_EXTRA_OPTS

build log
Code:

 * Package:    net-zope/zope-fixers-1.0
 * Repository: gentoo
 * Maintainer: python@gentoo.org
 * USE:        abi_x86_64 amd64 elibc_glibc kernel_linux multilib userland_GNU
 * FEATURES:   preserve-libs sandbox
>>> Unpacking source...
>>> Unpacking zope.fixers-1.0.tar.gz to /var/tmp/portage/net-zope/zope-fixers-1.0/work
>>> Source unpacked in /var/tmp/portage/net-zope/zope-fixers-1.0/work
>>> Preparing source in /var/tmp/portage/net-zope/zope-fixers-1.0/work/zope.fixers-1.0 ...
>>> Source prepared.
>>> Configuring source in /var/tmp/portage/net-zope/zope-fixers-1.0/work/zope.fixers-1.0 ...
>>> Source configured.
>>> Compiling source in /var/tmp/portage/net-zope/zope-fixers-1.0/work/zope.fixers-1.0 ...
 * Building of net-zope/zope-fixers-1.0 with CPython 2.7...
python2.7 setup.py build -b build-2.7
running build
running build_py
creating build-2.7
creating build-2.7/lib
creating build-2.7/lib/zope
copying zope/__init__.py -> build-2.7/lib/zope
creating build-2.7/lib/zope/fixers
copying zope/fixers/fix_class_provides.py -> build-2.7/lib/zope/fixers
copying zope/fixers/__init__.py -> build-2.7/lib/zope/fixers
copying zope/fixers/tests.py -> build-2.7/lib/zope/fixers
copying zope/fixers/fix_implements.py -> build-2.7/lib/zope/fixers
copying zope/fixers/fix_implements_only.py -> build-2.7/lib/zope/fixers
copying zope/fixers/base.py -> build-2.7/lib/zope/fixers
running egg_info
writing requirements to zope.fixers.egg-info/requires.txt
writing zope.fixers.egg-info/PKG-INFO
writing namespace_packages to zope.fixers.egg-info/namespace_packages.txt
writing top-level names to zope.fixers.egg-info/top_level.txt
writing dependency_links to zope.fixers.egg-info/dependency_links.txt
writing entry points to zope.fixers.egg-info/entry_points.txt
reading manifest file 'zope.fixers.egg-info/SOURCES.txt'
writing manifest file 'zope.fixers.egg-info/SOURCES.txt'
warning: build_py: byte-compiling is disabled, skipping.

 * Building of net-zope/zope-fixers-1.0 with PyPy 2.0 (Python 2.7)...
pypy-c2.0 setup.py build -b build-2.7-pypy-2.0
Traceback (most recent call last):
  File "app_main.py", line 72, in run_toplevel
  File "setup.py", line 19, in <module>
    from setuptools import setup, find_packages
ImportError: No module named setuptools
 * ERROR: net-zope/zope-fixers-1.0 failed (compile phase):
 *   Building failed with PyPy 2.0 (Python 2.7) in distutils_building() function
 *
 * Call stack:
 *     ebuild.sh, line   93:  Called src_compile
 *   environment, line 3644:  Called distutils_src_compile
 *   environment, line  987:  Called python_execute_function 'distutils_building'
 *   environment, line 2038:  Called die
 * The specific snippet of code:
 *                       die "${failure_message}";
 *
 * If you need support, post the output of `emerge --info '=net-zope/zope-fixers-1.0'`,
 * the complete build log and the output of `emerge -pqv '=net-zope/zope-fixers-1.0'`.
 * The complete build log is located at '/var/tmp/portage/net-zope/zope-fixers-1.0/temp/build.log'.
 * The ebuild environment file is located at '/var/tmp/portage/net-zope/zope-fixers-1.0/temp/environment'.
 * Working directory: '/var/tmp/portage/net-zope/zope-fixers-1.0/work/zope.fixers-1.0'
 * S: '/var/tmp/portage/net-zope/zope-fixers-1.0/work/zope.fixers-1.0'


Any suggestions?The issue seems (at least to me) to be clearly with getting portage to understand the use flags I want, and not with the build later ignoring the use flags in favor of some other property of my environment. If the issue persists after emerge --info net-zope/zope-fixers leaves "pypy2_0" out of python targets, then I'll tinker more with eselect and EPYTHON and other python settings.
For now though, how can I get portage to understand I don't want pypy in python_targets for net-zopes/zope-fixers?
Back to top
View user's profile Send private message
dol-sen
Developer
Developer


Joined: 30 Jun 2002
Posts: 2503
Location: Richmond, BC, Canada

PostPosted: Wed Jul 03, 2013 6:03 pm    Post subject: Reply with quote

If you try doing a pretend emerge with the -v option, it will tell you what USE flags are enabled, disabled.

If you did, you would see that zope-fixers-1.0 is using the old python eclass, so does not set any python_targets_* use flags. It still uses the USE_PYTHON variable in make.conf. However if you emerge zope-fixers-1.0-r1 it has been migrated to the new python -r1 eclasses which do use and set python_targets_* use flags.
_________________
Brian
Porthole, the Portage GUI frontend irc@freenode: #gentoo-guis, #porthole, Blog
layman, gentoolkit, CoreBuilder, esearch...
Back to top
View user's profile Send private message
stevenj36
n00b
n00b


Joined: 30 Jun 2013
Posts: 2

PostPosted: Wed Jul 03, 2013 7:21 pm    Post subject: Reply with quote

Thank you so much. I finished installing gentoo for the first time less than a week ago. I'm trying my best to figure things out on my own before posting here, but there's just quite a bit to learn all at once.

I'm still not quite sure how I could have known there was a zope-fixers-1.0-r1, or that it would solve my problem, but I'll mull over your response for a bit.

Thanks again!
Back to top
View user's profile Send private message
dol-sen
Developer
Developer


Joined: 30 Jun 2002
Posts: 2503
Location: Richmond, BC, Canada

PostPosted: Wed Jul 03, 2013 7:54 pm    Post subject: Reply with quote

Well, apps like app-portage/eix (command line search), app-portage/porthole (gtk gui frontend), app-portage/kuroo4 (kde/qt gui frontend) are great for showing what versions are available, their keywords, use flags, mask status etc..
_________________
Brian
Porthole, the Portage GUI frontend irc@freenode: #gentoo-guis, #porthole, Blog
layman, gentoolkit, CoreBuilder, esearch...
Back to top
View user's profile Send private message
Display posts from previous:   
Reply to topic    Gentoo Forums Forum Index Portage & Programming All times are GMT
Page 1 of 1

 
Jump to:  
You cannot post new topics in this forum
You cannot reply to topics in this forum
You cannot edit your posts in this forum
You cannot delete your posts in this forum
You cannot vote in polls in this forum